
#line 1 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"

#line 95 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"


#include "smtp_parsers.h"
#include "content_type.h"


#line 7 "/startdir/src/build/src/content_disposition.rl.c"
static const int content_type_parser_start = 1;
static const int content_type_parser_first_final = 44;
static const int content_type_parser_error = 0;

static const int content_type_parser_en_balanced_ccontent = 40;
static const int content_type_parser_en_main = 1;


#line 101 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"

gboolean
rspamd_content_disposition_parser (const char *data, size_t len, struct rspamd_content_disposition *cd, rspamd_mempool_t *pool)
{
  const unsigned char *p = data, *pe = data + len, *eof, *qstart = NULL, *qend = NULL,
    *pname_start = NULL, *pname_end = NULL, *pvalue_start = NULL, *pvalue_end = NULL;
  int cs, *stack = NULL;
  gsize top = 0;
  struct _ragel_st_storage {
    int *data;
    gsize size;
  } st_storage;

  memset (&st_storage, 0, sizeof (st_storage));
  memset (cd, 0, sizeof (*cd));
  eof = pe;

  
#line 31 "/startdir/src/build/src/content_disposition.rl.c"
	{
	cs = content_type_parser_start;
	top = 0;
	}

#line 119 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
  
#line 35 "/startdir/src/build/src/content_disposition.rl.c"
	{
	if ( p == pe )
		goto _test_eof;
	goto _resume;

_again:
	switch ( cs ) {
		case 1: goto st1;
		case 0: goto st0;
		case 44: goto st44;
		case 2: goto st2;
		case 3: goto st3;
		case 4: goto st4;
		case 5: goto st5;
		case 45: goto st45;
		case 46: goto st46;
		case 6: goto st6;
		case 7: goto st7;
		case 8: goto st8;
		case 9: goto st9;
		case 10: goto st10;
		case 11: goto st11;
		case 47: goto st47;
		case 12: goto st12;
		case 13: goto st13;
		case 14: goto st14;
		case 15: goto st15;
		case 16: goto st16;
		case 17: goto st17;
		case 18: goto st18;
		case 19: goto st19;
		case 20: goto st20;
		case 21: goto st21;
		case 22: goto st22;
		case 23: goto st23;
		case 24: goto st24;
		case 25: goto st25;
		case 26: goto st26;
		case 27: goto st27;
		case 28: goto st28;
		case 29: goto st29;
		case 30: goto st30;
		case 31: goto st31;
		case 32: goto st32;
		case 33: goto st33;
		case 34: goto st34;
		case 35: goto st35;
		case 36: goto st36;
		case 37: goto st37;
		case 38: goto st38;
		case 39: goto st39;
		case 48: goto st48;
		case 49: goto st49;
		case 50: goto st50;
		case 51: goto st51;
		case 52: goto st52;
		case 53: goto st53;
		case 54: goto st54;
		case 55: goto st55;
		case 56: goto st56;
		case 57: goto st57;
		case 58: goto st58;
		case 59: goto st59;
		case 60: goto st60;
		case 61: goto st61;
		case 62: goto st62;
		case 63: goto st63;
		case 40: goto st40;
		case 64: goto st64;
		case 41: goto st41;
		case 42: goto st42;
		case 43: goto st43;
	default: break;
	}

	if ( ++p == pe )
		goto _test_eof;
_resume:
	switch ( cs )
	{
st1:
	if ( ++p == pe )
		goto _test_eof1;
case 1:
	switch( (*p) ) {
		case 65u: goto tr2;
		case 73u: goto tr3;
		case 97u: goto tr2;
		case 105u: goto tr3;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto tr0;
		} else if ( (*p) >= 33u )
			goto tr0;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto tr0;
		} else if ( (*p) >= 66u )
			goto tr0;
	} else
		goto tr0;
	goto st0;
st0:
cs = 0;
	goto _out;
tr0:
#line 5 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st44;
st44:
	if ( ++p == pe )
		goto _test_eof44;
case 44:
#line 151 "/startdir/src/build/src/content_disposition.rl.c"
	if ( (*p) == 59u )
		goto tr80;
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
tr4:
#line 19 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;
    pname_start = p;
    pname_end = NULL;
  }
	goto st2;
tr80:
#line 8 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st2;
tr84:
#line 52 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	goto st2;
tr96:
#line 15 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    cd->type = RSPAMD_CT_ATTACHMENT;
  }
#line 8 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st2;
tr102:
#line 11 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    cd->type = RSPAMD_CT_INLINE;
  }
#line 8 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st2;
st2:
	if ( ++p == pe )
		goto _test_eof2;
case 2:
#line 226 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32u: goto tr4;
		case 34u: goto tr6;
		case 40u: goto tr7;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto tr5;
		} else if ( (*p) >= 33u )
			goto tr5;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto tr5;
		} else if ( (*p) >= 65u )
			goto tr5;
	} else
		goto tr5;
	goto st0;
tr5:
#line 19 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;
    pname_start = p;
    pname_end = NULL;
  }
	goto st3;
st3:
	if ( ++p == pe )
		goto _test_eof3;
case 3:
#line 258 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32u: goto tr8;
		case 33u: goto st3;
		case 61u: goto tr10;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st3;
		} else if ( (*p) >= 35u )
			goto st3;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st3;
		} else if ( (*p) >= 65u )
			goto st3;
	} else
		goto st3;
	goto st0;
tr8:
#line 26 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      pname_start = qstart;
    }
    if (qend && qend >= qstart) {
      pname_end = qend;
    }
    else if (p >= pname_start) {
      pname_end = p;
    }
    qstart = NULL;
    qend = NULL;
  }
	goto st4;
st4:
	if ( ++p == pe )
		goto _test_eof4;
case 4:
#line 297 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32u: goto st4;
		case 61u: goto st5;
	}
	goto st0;
tr10:
#line 26 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      pname_start = qstart;
    }
    if (qend && qend >= qstart) {
      pname_end = qend;
    }
    else if (p >= pname_start) {
      pname_end = p;
    }
    qstart = NULL;
    qend = NULL;
  }
	goto st5;
tr13:
#line 41 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;

    if (pname_end) {
      pvalue_start = p;
      pvalue_end = NULL;
    }
  }
	goto st5;
st5:
	if ( ++p == pe )
		goto _test_eof5;
case 5:
#line 332 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32u: goto tr13;
		case 34u: goto tr15;
		case 40u: goto tr16;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto tr14;
		} else if ( (*p) >= 33u )
			goto tr14;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto tr14;
		} else if ( (*p) >= 65u )
			goto tr14;
	} else
		goto tr14;
	goto st0;
tr14:
#line 41 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;

    if (pname_end) {
      pvalue_start = p;
      pvalue_end = NULL;
    }
  }
	goto st45;
st45:
	if ( ++p == pe )
		goto _test_eof45;
case 45:
#line 367 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32u: goto tr81;
		case 33u: goto st45;
		case 40u: goto tr83;
		case 59u: goto tr84;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st45;
		} else if ( (*p) >= 35u )
			goto st45;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st45;
		} else if ( (*p) >= 65u )
			goto st45;
	} else
		goto st45;
	goto st0;
tr81:
#line 52 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	goto st46;
st46:
	if ( ++p == pe )
		goto _test_eof46;
case 46:
#line 420 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32u: goto st46;
		case 40u: goto st6;
		case 59u: goto st2;
	}
	goto st0;
tr18:
#line 6 "/startdir/src/rspamd/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 6;goto st40;}} }
	goto st6;
tr83:
#line 52 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	goto st6;
st6:
	if ( ++p == pe )
		goto _test_eof6;
case 6:
#line 468 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40u: goto tr18;
		case 41u: goto st46;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 91u ) {
			if ( 93u <= (*p) && (*p) <= 126u )
				goto st6;
		} else if ( (*p) >= 32u )
			goto st6;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st9;
		} else if ( (*p) >= 224u )
			goto st8;
	} else
		goto st7;
	goto st0;
st7:
	if ( ++p == pe )
		goto _test_eof7;
case 7:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st6;
	goto st0;
st8:
	if ( ++p == pe )
		goto _test_eof8;
case 8:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st7;
	goto st0;
st9:
	if ( ++p == pe )
		goto _test_eof9;
case 9:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st8;
	goto st0;
tr15:
#line 41 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;

    if (pname_end) {
      pvalue_start = p;
      pvalue_end = NULL;
    }
  }
	goto st10;
st10:
	if ( ++p == pe )
		goto _test_eof10;
case 10:
#line 523 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 34u: goto tr24;
		case 92u: goto tr25;
	}
	if ( (*p) < 192u ) {
		if ( 32u <= (*p) && (*p) <= 126u )
			goto tr23;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto tr28;
		} else if ( (*p) >= 224u )
			goto tr27;
	} else
		goto tr26;
	goto st0;
tr23:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st11;
st11:
	if ( ++p == pe )
		goto _test_eof11;
case 11:
#line 549 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 34u: goto tr30;
		case 92u: goto st16;
	}
	if ( (*p) < 192u ) {
		if ( 32u <= (*p) && (*p) <= 126u )
			goto st11;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st19;
		} else if ( (*p) >= 224u )
			goto st18;
	} else
		goto st17;
	goto st0;
tr24:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
#line 84 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      qend = p;
    }
  }
	goto st47;
tr30:
#line 84 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      qend = p;
    }
  }
	goto st47;
tr85:
#line 52 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	goto st47;
st47:
	if ( ++p == pe )
		goto _test_eof47;
case 47:
#line 615 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32u: goto tr85;
		case 40u: goto tr86;
		case 59u: goto tr84;
	}
	goto st0;
tr36:
#line 6 "/startdir/src/rspamd/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 12;goto st40;}} }
	goto st12;
tr86:
#line 52 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	goto st12;
st12:
	if ( ++p == pe )
		goto _test_eof12;
case 12:
#line 663 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40u: goto tr36;
		case 41u: goto st47;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 91u ) {
			if ( 93u <= (*p) && (*p) <= 126u )
				goto st12;
		} else if ( (*p) >= 32u )
			goto st12;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st15;
		} else if ( (*p) >= 224u )
			goto st14;
	} else
		goto st13;
	goto st0;
st13:
	if ( ++p == pe )
		goto _test_eof13;
case 13:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st12;
	goto st0;
st14:
	if ( ++p == pe )
		goto _test_eof14;
case 14:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st13;
	goto st0;
st15:
	if ( ++p == pe )
		goto _test_eof15;
case 15:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st14;
	goto st0;
tr25:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st16;
st16:
	if ( ++p == pe )
		goto _test_eof16;
case 16:
#line 713 "/startdir/src/build/src/content_disposition.rl.c"
	if ( 32u <= (*p) && (*p) <= 126u )
		goto st11;
	goto st0;
tr26:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st17;
st17:
	if ( ++p == pe )
		goto _test_eof17;
case 17:
#line 726 "/startdir/src/build/src/content_disposition.rl.c"
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st11;
	goto st0;
tr27:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st18;
st18:
	if ( ++p == pe )
		goto _test_eof18;
case 18:
#line 739 "/startdir/src/build/src/content_disposition.rl.c"
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st17;
	goto st0;
tr28:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st19;
st19:
	if ( ++p == pe )
		goto _test_eof19;
case 19:
#line 752 "/startdir/src/build/src/content_disposition.rl.c"
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st18;
	goto st0;
tr16:
#line 41 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;

    if (pname_end) {
      pvalue_start = p;
      pvalue_end = NULL;
    }
  }
	goto st20;
tr42:
#line 6 "/startdir/src/rspamd/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 20;goto st40;}} }
	goto st20;
st20:
	if ( ++p == pe )
		goto _test_eof20;
case 20:
#line 780 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40u: goto tr42;
		case 41u: goto st21;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 91u ) {
			if ( 93u <= (*p) && (*p) <= 126u )
				goto st20;
		} else if ( (*p) >= 32u )
			goto st20;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st24;
		} else if ( (*p) >= 224u )
			goto st23;
	} else
		goto st22;
	goto st0;
st21:
	if ( ++p == pe )
		goto _test_eof21;
case 21:
	switch( (*p) ) {
		case 32u: goto st21;
		case 34u: goto st10;
		case 40u: goto st20;
	}
	goto st0;
st22:
	if ( ++p == pe )
		goto _test_eof22;
case 22:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st20;
	goto st0;
st23:
	if ( ++p == pe )
		goto _test_eof23;
case 23:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st22;
	goto st0;
st24:
	if ( ++p == pe )
		goto _test_eof24;
case 24:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st23;
	goto st0;
tr6:
#line 19 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;
    pname_start = p;
    pname_end = NULL;
  }
	goto st25;
st25:
	if ( ++p == pe )
		goto _test_eof25;
case 25:
#line 842 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 34u: goto tr49;
		case 92u: goto tr50;
	}
	if ( (*p) < 192u ) {
		if ( 32u <= (*p) && (*p) <= 126u )
			goto tr48;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto tr53;
		} else if ( (*p) >= 224u )
			goto tr52;
	} else
		goto tr51;
	goto st0;
tr48:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st26;
st26:
	if ( ++p == pe )
		goto _test_eof26;
case 26:
#line 868 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 34u: goto tr55;
		case 92u: goto st32;
	}
	if ( (*p) < 192u ) {
		if ( 32u <= (*p) && (*p) <= 126u )
			goto st26;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st35;
		} else if ( (*p) >= 224u )
			goto st34;
	} else
		goto st33;
	goto st0;
tr60:
#line 26 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      pname_start = qstart;
    }
    if (qend && qend >= qstart) {
      pname_end = qend;
    }
    else if (p >= pname_start) {
      pname_end = p;
    }
    qstart = NULL;
    qend = NULL;
  }
	goto st27;
tr49:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
#line 84 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      qend = p;
    }
  }
	goto st27;
tr55:
#line 84 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      qend = p;
    }
  }
	goto st27;
st27:
	if ( ++p == pe )
		goto _test_eof27;
case 27:
#line 921 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32u: goto tr60;
		case 40u: goto st28;
		case 61u: goto tr10;
	}
	goto st0;
tr62:
#line 6 "/startdir/src/rspamd/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 28;goto st40;}} }
	goto st28;
st28:
	if ( ++p == pe )
		goto _test_eof28;
case 28:
#line 941 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40u: goto tr62;
		case 41u: goto st27;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 91u ) {
			if ( 93u <= (*p) && (*p) <= 126u )
				goto st28;
		} else if ( (*p) >= 32u )
			goto st28;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st31;
		} else if ( (*p) >= 224u )
			goto st30;
	} else
		goto st29;
	goto st0;
st29:
	if ( ++p == pe )
		goto _test_eof29;
case 29:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st28;
	goto st0;
st30:
	if ( ++p == pe )
		goto _test_eof30;
case 30:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st29;
	goto st0;
st31:
	if ( ++p == pe )
		goto _test_eof31;
case 31:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st30;
	goto st0;
tr50:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st32;
st32:
	if ( ++p == pe )
		goto _test_eof32;
case 32:
#line 991 "/startdir/src/build/src/content_disposition.rl.c"
	if ( 32u <= (*p) && (*p) <= 126u )
		goto st26;
	goto st0;
tr51:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st33;
st33:
	if ( ++p == pe )
		goto _test_eof33;
case 33:
#line 1004 "/startdir/src/build/src/content_disposition.rl.c"
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st26;
	goto st0;
tr52:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st34;
st34:
	if ( ++p == pe )
		goto _test_eof34;
case 34:
#line 1017 "/startdir/src/build/src/content_disposition.rl.c"
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st33;
	goto st0;
tr53:
#line 79 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st35;
st35:
	if ( ++p == pe )
		goto _test_eof35;
case 35:
#line 1030 "/startdir/src/build/src/content_disposition.rl.c"
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st34;
	goto st0;
tr7:
#line 19 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;
    pname_start = p;
    pname_end = NULL;
  }
	goto st36;
tr68:
#line 6 "/startdir/src/rspamd/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 36;goto st40;}} }
	goto st36;
st36:
	if ( ++p == pe )
		goto _test_eof36;
case 36:
#line 1055 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40u: goto tr68;
		case 41u: goto st2;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 91u ) {
			if ( 93u <= (*p) && (*p) <= 126u )
				goto st36;
		} else if ( (*p) >= 32u )
			goto st36;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st39;
		} else if ( (*p) >= 224u )
			goto st38;
	} else
		goto st37;
	goto st0;
st37:
	if ( ++p == pe )
		goto _test_eof37;
case 37:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st36;
	goto st0;
st38:
	if ( ++p == pe )
		goto _test_eof38;
case 38:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st37;
	goto st0;
st39:
	if ( ++p == pe )
		goto _test_eof39;
case 39:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st38;
	goto st0;
tr2:
#line 5 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st48;
st48:
	if ( ++p == pe )
		goto _test_eof48;
case 48:
#line 1103 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 59u: goto tr80;
		case 84u: goto st49;
		case 116u: goto st49;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st49:
	if ( ++p == pe )
		goto _test_eof49;
case 49:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 84u: goto st50;
		case 116u: goto st50;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st50:
	if ( ++p == pe )
		goto _test_eof50;
case 50:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 65u: goto st51;
		case 97u: goto st51;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 66u )
			goto st44;
	} else
		goto st44;
	goto st0;
st51:
	if ( ++p == pe )
		goto _test_eof51;
case 51:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 67u: goto st52;
		case 99u: goto st52;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st52:
	if ( ++p == pe )
		goto _test_eof52;
case 52:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 72u: goto st53;
		case 104u: goto st53;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st53:
	if ( ++p == pe )
		goto _test_eof53;
case 53:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 77u: goto st54;
		case 109u: goto st54;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st54:
	if ( ++p == pe )
		goto _test_eof54;
case 54:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 69u: goto st55;
		case 101u: goto st55;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st55:
	if ( ++p == pe )
		goto _test_eof55;
case 55:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 78u: goto st56;
		case 110u: goto st56;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st56:
	if ( ++p == pe )
		goto _test_eof56;
case 56:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 84u: goto st57;
		case 116u: goto st57;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st57:
	if ( ++p == pe )
		goto _test_eof57;
case 57:
	if ( (*p) == 59u )
		goto tr96;
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
tr3:
#line 5 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st58;
st58:
	if ( ++p == pe )
		goto _test_eof58;
case 58:
#line 1344 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 59u: goto tr80;
		case 78u: goto st59;
		case 110u: goto st59;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st59:
	if ( ++p == pe )
		goto _test_eof59;
case 59:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 76u: goto st60;
		case 108u: goto st60;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st60:
	if ( ++p == pe )
		goto _test_eof60;
case 60:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 73u: goto st61;
		case 105u: goto st61;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st61:
	if ( ++p == pe )
		goto _test_eof61;
case 61:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 78u: goto st62;
		case 110u: goto st62;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st62:
	if ( ++p == pe )
		goto _test_eof62;
case 62:
	switch( (*p) ) {
		case 59u: goto tr80;
		case 69u: goto st63;
		case 101u: goto st63;
	}
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
st63:
	if ( ++p == pe )
		goto _test_eof63;
case 63:
	if ( (*p) == 59u )
		goto tr102;
	if ( (*p) < 48u ) {
		if ( (*p) > 39u ) {
			if ( 42u <= (*p) && (*p) <= 46u )
				goto st44;
		} else if ( (*p) >= 33u )
			goto st44;
	} else if ( (*p) > 57u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st44;
		} else if ( (*p) >= 65u )
			goto st44;
	} else
		goto st44;
	goto st0;
tr74:
#line 6 "/startdir/src/rspamd/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 40;goto st40;}} }
	goto st40;
st40:
	if ( ++p == pe )
		goto _test_eof40;
case 40:
#line 1495 "/startdir/src/build/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40u: goto tr74;
		case 41u: goto tr75;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 91u ) {
			if ( 93u <= (*p) && (*p) <= 126u )
				goto st40;
		} else if ( (*p) >= 32u )
			goto st40;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st43;
		} else if ( (*p) >= 224u )
			goto st42;
	} else
		goto st41;
	goto st0;
tr75:
#line 7 "/startdir/src/rspamd/src/ragel/content_disposition.rl"
	{ {cs = stack[--top];goto _again;} }
	goto st64;
st64:
	if ( ++p == pe )
		goto _test_eof64;
case 64:
#line 1521 "/startdir/src/build/src/content_disposition.rl.c"
	goto st0;
st41:
	if ( ++p == pe )
		goto _test_eof41;
case 41:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st40;
	goto st0;
st42:
	if ( ++p == pe )
		goto _test_eof42;
case 42:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st41;
	goto st0;
st43:
	if ( ++p == pe )
		goto _test_eof43;
case 43:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st42;
	goto st0;
	}
	_test_eof1: cs = 1; goto _test_eof; 
	_test_eof44: cs = 44; goto _test_eof; 
	_test_eof2: cs = 2; goto _test_eof; 
	_test_eof3: cs = 3; goto _test_eof; 
	_test_eof4: cs = 4; goto _test_eof; 
	_test_eof5: cs = 5; goto _test_eof; 
	_test_eof45: cs = 45; goto _test_eof; 
	_test_eof46: cs = 46; goto _test_eof; 
	_test_eof6: cs = 6; goto _test_eof; 
	_test_eof7: cs = 7; goto _test_eof; 
	_test_eof8: cs = 8; goto _test_eof; 
	_test_eof9: cs = 9; goto _test_eof; 
	_test_eof10: cs = 10; goto _test_eof; 
	_test_eof11: cs = 11; goto _test_eof; 
	_test_eof47: cs = 47; goto _test_eof; 
	_test_eof12: cs = 12; goto _test_eof; 
	_test_eof13: cs = 13; goto _test_eof; 
	_test_eof14: cs = 14; goto _test_eof; 
	_test_eof15: cs = 15; goto _test_eof; 
	_test_eof16: cs = 16; goto _test_eof; 
	_test_eof17: cs = 17; goto _test_eof; 
	_test_eof18: cs = 18; goto _test_eof; 
	_test_eof19: cs = 19; goto _test_eof; 
	_test_eof20: cs = 20; goto _test_eof; 
	_test_eof21: cs = 21; goto _test_eof; 
	_test_eof22: cs = 22; goto _test_eof; 
	_test_eof23: cs = 23; goto _test_eof; 
	_test_eof24: cs = 24; goto _test_eof; 
	_test_eof25: cs = 25; goto _test_eof; 
	_test_eof26: cs = 26; goto _test_eof; 
	_test_eof27: cs = 27; goto _test_eof; 
	_test_eof28: cs = 28; goto _test_eof; 
	_test_eof29: cs = 29; goto _test_eof; 
	_test_eof30: cs = 30; goto _test_eof; 
	_test_eof31: cs = 31; goto _test_eof; 
	_test_eof32: cs = 32; goto _test_eof; 
	_test_eof33: cs = 33; goto _test_eof; 
	_test_eof34: cs = 34; goto _test_eof; 
	_test_eof35: cs = 35; goto _test_eof; 
	_test_eof36: cs = 36; goto _test_eof; 
	_test_eof37: cs = 37; goto _test_eof; 
	_test_eof38: cs = 38; goto _test_eof; 
	_test_eof39: cs = 39; goto _test_eof; 
	_test_eof48: cs = 48; goto _test_eof; 
	_test_eof49: cs = 49; goto _test_eof; 
	_test_eof50: cs = 50; goto _test_eof; 
	_test_eof51: cs = 51; goto _test_eof; 
	_test_eof52: cs = 52; goto _test_eof; 
	_test_eof53: cs = 53; goto _test_eof; 
	_test_eof54: cs = 54; goto _test_eof; 
	_test_eof55: cs = 55; goto _test_eof; 
	_test_eof56: cs = 56; goto _test_eof; 
	_test_eof57: cs = 57; goto _test_eof; 
	_test_eof58: cs = 58; goto _test_eof; 
	_test_eof59: cs = 59; goto _test_eof; 
	_test_eof60: cs = 60; goto _test_eof; 
	_test_eof61: cs = 61; goto _test_eof; 
	_test_eof62: cs = 62; goto _test_eof; 
	_test_eof63: cs = 63; goto _test_eof; 
	_test_eof40: cs = 40; goto _test_eof; 
	_test_eof64: cs = 64; goto _test_eof; 
	_test_eof41: cs = 41; goto _test_eof; 
	_test_eof42: cs = 42; goto _test_eof; 
	_test_eof43: cs = 43; goto _test_eof; 

	_test_eof: {}
	if ( p == eof )
	{
	switch ( cs ) {
	case 44: 
	case 48: 
	case 49: 
	case 50: 
	case 51: 
	case 52: 
	case 53: 
	case 54: 
	case 55: 
	case 56: 
	case 58: 
	case 59: 
	case 60: 
	case 61: 
	case 62: 
#line 8 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
  }
	break;
	case 45: 
	case 47: 
#line 52 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	break;
	case 63: 
#line 11 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    cd->type = RSPAMD_CT_INLINE;
  }
#line 8 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
  }
	break;
	case 57: 
#line 15 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
    cd->type = RSPAMD_CT_ATTACHMENT;
  }
#line 8 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"
	{
  }
	break;
#line 1674 "/startdir/src/build/src/content_disposition.rl.c"
	}
	}

	_out: {}
	}

#line 120 "/startdir/src/rspamd/src/ragel/content_disposition_parser.rl"

  if (st_storage.data) {
    free (st_storage.data);
  }

  return cd->attrs != NULL || cd->type != RSPAMD_CT_UNKNOWN;
}
