
#line 1 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"

#line 31 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"


#include "smtp_parsers.h"
#include "util.h"
#include "addr.h"


#line 8 "/startdir/src/build/src/ip_parser.rl.c"
static const int smtp_ip_parser_start = 1;
static const int smtp_ip_parser_first_final = 161;
static const int smtp_ip_parser_error = 0;

static const int smtp_ip_parser_en_main = 1;


#line 38 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"

rspamd_inet_addr_t *
rspamd_parse_smtp_ip (const char *data, size_t len, rspamd_mempool_t *pool)
{
  const char *p = data, *pe = data + len, *eof = data + len;
  const char *ip_start = NULL, *ip_end = NULL;
  gboolean in_v6 = FALSE;
  int cs = 0;

  
#line 23 "/startdir/src/build/src/ip_parser.rl.c"
	{
	cs = smtp_ip_parser_start;
	}

#line 48 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
  
#line 26 "/startdir/src/build/src/ip_parser.rl.c"
	{
	if ( p == pe )
		goto _test_eof;
	switch ( cs )
	{
case 1:
	if ( (*p) == 91u )
		goto st14;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto tr0;
	goto st0;
st0:
cs = 0;
	goto _out;
tr0:
#line 24 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
#line 13 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_start = p;
    }
  }
	goto st2;
st2:
	if ( ++p == pe )
		goto _test_eof2;
case 2:
#line 52 "/startdir/src/build/src/ip_parser.rl.c"
	if ( (*p) == 46u )
		goto st3;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st12;
	goto st0;
st3:
	if ( ++p == pe )
		goto _test_eof3;
case 3:
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st4;
	goto st0;
st4:
	if ( ++p == pe )
		goto _test_eof4;
case 4:
	if ( (*p) == 46u )
		goto st5;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st10;
	goto st0;
st5:
	if ( ++p == pe )
		goto _test_eof5;
case 5:
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st6;
	goto st0;
st6:
	if ( ++p == pe )
		goto _test_eof6;
case 6:
	if ( (*p) == 46u )
		goto st7;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st8;
	goto st0;
st7:
	if ( ++p == pe )
		goto _test_eof7;
case 7:
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st161;
	goto st0;
st161:
	if ( ++p == pe )
		goto _test_eof161;
case 161:
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st162;
	goto st0;
st162:
	if ( ++p == pe )
		goto _test_eof162;
case 162:
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st163;
	goto st0;
st163:
	if ( ++p == pe )
		goto _test_eof163;
case 163:
	goto st0;
st8:
	if ( ++p == pe )
		goto _test_eof8;
case 8:
	if ( (*p) == 46u )
		goto st7;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st9;
	goto st0;
st9:
	if ( ++p == pe )
		goto _test_eof9;
case 9:
	if ( (*p) == 46u )
		goto st7;
	goto st0;
st10:
	if ( ++p == pe )
		goto _test_eof10;
case 10:
	if ( (*p) == 46u )
		goto st5;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st11;
	goto st0;
st11:
	if ( ++p == pe )
		goto _test_eof11;
case 11:
	if ( (*p) == 46u )
		goto st5;
	goto st0;
st12:
	if ( ++p == pe )
		goto _test_eof12;
case 12:
	if ( (*p) == 46u )
		goto st3;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st13;
	goto st0;
st13:
	if ( ++p == pe )
		goto _test_eof13;
case 13:
	if ( (*p) == 46u )
		goto st3;
	goto st0;
st14:
	if ( ++p == pe )
		goto _test_eof14;
case 14:
	switch( (*p) ) {
		case 45u: goto tr15;
		case 73u: goto tr18;
		case 95u: goto tr15;
	}
	if ( (*p) < 97u ) {
		if ( (*p) > 57u ) {
			if ( 65u <= (*p) && (*p) <= 90u )
				goto tr17;
		} else if ( (*p) >= 48u )
			goto tr16;
	} else if ( (*p) > 122u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto tr19;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto tr21;
		} else
			goto tr20;
	} else
		goto tr17;
	goto st0;
tr15:
#line 24 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	goto st15;
st15:
	if ( ++p == pe )
		goto _test_eof15;
case 15:
#line 197 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 45u: goto st15;
		case 95u: goto st15;
	}
	if ( (*p) < 97u ) {
		if ( (*p) > 57u ) {
			if ( 65u <= (*p) && (*p) <= 90u )
				goto st16;
		} else if ( (*p) >= 48u )
			goto st16;
	} else if ( (*p) > 122u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st22;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st24;
		} else
			goto st23;
	} else
		goto st16;
	goto st0;
tr17:
#line 24 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	goto st16;
st16:
	if ( ++p == pe )
		goto _test_eof16;
case 16:
#line 226 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 45u: goto st15;
		case 58u: goto st17;
		case 95u: goto st15;
	}
	if ( (*p) < 97u ) {
		if ( (*p) > 57u ) {
			if ( 65u <= (*p) && (*p) <= 90u )
				goto st16;
		} else if ( (*p) >= 48u )
			goto st16;
	} else if ( (*p) > 122u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st22;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st24;
		} else
			goto st23;
	} else
		goto st16;
	goto st0;
st17:
	if ( ++p == pe )
		goto _test_eof17;
case 17:
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st18:
	if ( ++p == pe )
		goto _test_eof18;
case 18:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
tr32:
#line 25 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	goto st164;
tr43:
#line 18 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_end = p;
    }
  }
#line 25 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	goto st164;
tr99:
#line 18 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_end = p;
    }
  }
#line 9 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    in_v6 = 0;
    ip_end = p;
  }
#line 25 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	goto st164;
tr108:
#line 9 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    in_v6 = 0;
    ip_end = p;
  }
#line 25 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	goto st164;
st164:
	if ( ++p == pe )
		goto _test_eof164;
case 164:
#line 323 "/startdir/src/build/src/ip_parser.rl.c"
	goto st0;
st19:
	if ( ++p == pe )
		goto _test_eof19;
case 19:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st18;
	goto st0;
st20:
	if ( ++p == pe )
		goto _test_eof20;
case 20:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st19;
	goto st0;
st21:
	if ( ++p == pe )
		goto _test_eof21;
case 21:
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st20;
	goto st0;
tr19:
#line 24 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	goto st22;
st22:
	if ( ++p == pe )
		goto _test_eof22;
case 22:
#line 352 "/startdir/src/build/src/ip_parser.rl.c"
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st16;
	goto st0;
tr20:
#line 24 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	goto st23;
st23:
	if ( ++p == pe )
		goto _test_eof23;
case 23:
#line 362 "/startdir/src/build/src/ip_parser.rl.c"
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st22;
	goto st0;
tr21:
#line 24 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	goto st24;
st24:
	if ( ++p == pe )
		goto _test_eof24;
case 24:
#line 372 "/startdir/src/build/src/ip_parser.rl.c"
	if ( 128u <= (*p) && (*p) <= 191u )
		goto st23;
	goto st0;
tr16:
#line 24 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
#line 13 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_start = p;
    }
  }
	goto st25;
st25:
	if ( ++p == pe )
		goto _test_eof25;
case 25:
#line 387 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 45u: goto st15;
		case 46u: goto st26;
		case 58u: goto st17;
		case 95u: goto st15;
	}
	if ( (*p) < 97u ) {
		if ( (*p) > 57u ) {
			if ( 65u <= (*p) && (*p) <= 90u )
				goto st16;
		} else if ( (*p) >= 48u )
			goto st38;
	} else if ( (*p) > 122u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st22;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st24;
		} else
			goto st23;
	} else
		goto st16;
	goto st0;
st26:
	if ( ++p == pe )
		goto _test_eof26;
case 26:
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st27;
	goto st0;
st27:
	if ( ++p == pe )
		goto _test_eof27;
case 27:
	if ( (*p) == 46u )
		goto st28;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st36;
	goto st0;
st28:
	if ( ++p == pe )
		goto _test_eof28;
case 28:
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st29;
	goto st0;
st29:
	if ( ++p == pe )
		goto _test_eof29;
case 29:
	if ( (*p) == 46u )
		goto st30;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st34;
	goto st0;
st30:
	if ( ++p == pe )
		goto _test_eof30;
case 30:
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st31;
	goto st0;
st31:
	if ( ++p == pe )
		goto _test_eof31;
case 31:
	if ( (*p) == 93u )
		goto tr43;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st32;
	goto st0;
st32:
	if ( ++p == pe )
		goto _test_eof32;
case 32:
	if ( (*p) == 93u )
		goto tr43;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st33;
	goto st0;
st33:
	if ( ++p == pe )
		goto _test_eof33;
case 33:
	if ( (*p) == 93u )
		goto tr43;
	goto st0;
st34:
	if ( ++p == pe )
		goto _test_eof34;
case 34:
	if ( (*p) == 46u )
		goto st30;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st35;
	goto st0;
st35:
	if ( ++p == pe )
		goto _test_eof35;
case 35:
	if ( (*p) == 46u )
		goto st30;
	goto st0;
st36:
	if ( ++p == pe )
		goto _test_eof36;
case 36:
	if ( (*p) == 46u )
		goto st28;
	if ( 48u <= (*p) && (*p) <= 57u )
		goto st37;
	goto st0;
st37:
	if ( ++p == pe )
		goto _test_eof37;
case 37:
	if ( (*p) == 46u )
		goto st28;
	goto st0;
st38:
	if ( ++p == pe )
		goto _test_eof38;
case 38:
	switch( (*p) ) {
		case 45u: goto st15;
		case 46u: goto st26;
		case 58u: goto st17;
		case 95u: goto st15;
	}
	if ( (*p) < 97u ) {
		if ( (*p) > 57u ) {
			if ( 65u <= (*p) && (*p) <= 90u )
				goto st16;
		} else if ( (*p) >= 48u )
			goto st39;
	} else if ( (*p) > 122u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st22;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st24;
		} else
			goto st23;
	} else
		goto st16;
	goto st0;
st39:
	if ( ++p == pe )
		goto _test_eof39;
case 39:
	switch( (*p) ) {
		case 45u: goto st15;
		case 46u: goto st26;
		case 58u: goto st17;
		case 95u: goto st15;
	}
	if ( (*p) < 97u ) {
		if ( (*p) > 57u ) {
			if ( 65u <= (*p) && (*p) <= 90u )
				goto st16;
		} else if ( (*p) >= 48u )
			goto st16;
	} else if ( (*p) > 122u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st22;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st24;
		} else
			goto st23;
	} else
		goto st16;
	goto st0;
tr18:
#line 24 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	goto st40;
st40:
	if ( ++p == pe )
		goto _test_eof40;
case 40:
#line 570 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 45u: goto st15;
		case 58u: goto st17;
		case 80u: goto st41;
		case 95u: goto st15;
	}
	if ( (*p) < 97u ) {
		if ( (*p) > 57u ) {
			if ( 65u <= (*p) && (*p) <= 90u )
				goto st16;
		} else if ( (*p) >= 48u )
			goto st16;
	} else if ( (*p) > 122u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st22;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st24;
		} else
			goto st23;
	} else
		goto st16;
	goto st0;
st41:
	if ( ++p == pe )
		goto _test_eof41;
case 41:
	switch( (*p) ) {
		case 45u: goto st15;
		case 58u: goto st17;
		case 95u: goto st15;
		case 118u: goto st42;
	}
	if ( (*p) < 97u ) {
		if ( (*p) > 57u ) {
			if ( 65u <= (*p) && (*p) <= 90u )
				goto st16;
		} else if ( (*p) >= 48u )
			goto st16;
	} else if ( (*p) > 122u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st22;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st24;
		} else
			goto st23;
	} else
		goto st16;
	goto st0;
st42:
	if ( ++p == pe )
		goto _test_eof42;
case 42:
	switch( (*p) ) {
		case 45u: goto st15;
		case 54u: goto st43;
		case 58u: goto st17;
		case 95u: goto st15;
	}
	if ( (*p) < 97u ) {
		if ( (*p) > 57u ) {
			if ( 65u <= (*p) && (*p) <= 90u )
				goto st16;
		} else if ( (*p) >= 48u )
			goto st16;
	} else if ( (*p) > 122u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st22;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st24;
		} else
			goto st23;
	} else
		goto st16;
	goto st0;
st43:
	if ( ++p == pe )
		goto _test_eof43;
case 43:
	switch( (*p) ) {
		case 45u: goto st15;
		case 58u: goto st44;
		case 95u: goto st15;
	}
	if ( (*p) < 97u ) {
		if ( (*p) > 57u ) {
			if ( 65u <= (*p) && (*p) <= 90u )
				goto st16;
		} else if ( (*p) >= 48u )
			goto st16;
	} else if ( (*p) > 122u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st22;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st24;
		} else
			goto st23;
	} else
		goto st16;
	goto st0;
st44:
	if ( ++p == pe )
		goto _test_eof44;
case 44:
	if ( (*p) == 58u )
		goto tr53;
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto tr52;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto tr52;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto tr52;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
tr52:
#line 5 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    in_v6 = 1;
    ip_start = p;
  }
	goto st45;
st45:
	if ( ++p == pe )
		goto _test_eof45;
case 45:
#line 726 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 58u: goto st49;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st46;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st46;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st46;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st46:
	if ( ++p == pe )
		goto _test_eof46;
case 46:
	switch( (*p) ) {
		case 58u: goto st49;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st47;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st47;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st47;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st47:
	if ( ++p == pe )
		goto _test_eof47;
case 47:
	switch( (*p) ) {
		case 58u: goto st49;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st48;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st48;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st48;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st48:
	if ( ++p == pe )
		goto _test_eof48;
case 48:
	switch( (*p) ) {
		case 58u: goto st49;
		case 93u: goto tr32;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st49:
	if ( ++p == pe )
		goto _test_eof49;
case 49:
	switch( (*p) ) {
		case 58u: goto st124;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st50;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st50;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st50;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st50:
	if ( ++p == pe )
		goto _test_eof50;
case 50:
	switch( (*p) ) {
		case 58u: goto st54;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st51;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st51;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st51;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st51:
	if ( ++p == pe )
		goto _test_eof51;
case 51:
	switch( (*p) ) {
		case 58u: goto st54;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st52;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st52;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st52;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st52:
	if ( ++p == pe )
		goto _test_eof52;
case 52:
	switch( (*p) ) {
		case 58u: goto st54;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st53;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st53;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st53;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st53:
	if ( ++p == pe )
		goto _test_eof53;
case 53:
	switch( (*p) ) {
		case 58u: goto st54;
		case 93u: goto tr32;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st54:
	if ( ++p == pe )
		goto _test_eof54;
case 54:
	switch( (*p) ) {
		case 58u: goto st124;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st55;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st55;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st55;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st55:
	if ( ++p == pe )
		goto _test_eof55;
case 55:
	switch( (*p) ) {
		case 58u: goto st59;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st56;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st56;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st56;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st56:
	if ( ++p == pe )
		goto _test_eof56;
case 56:
	switch( (*p) ) {
		case 58u: goto st59;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st57;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st57;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st57;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st57:
	if ( ++p == pe )
		goto _test_eof57;
case 57:
	switch( (*p) ) {
		case 58u: goto st59;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st58;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st58;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st58;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st58:
	if ( ++p == pe )
		goto _test_eof58;
case 58:
	switch( (*p) ) {
		case 58u: goto st59;
		case 93u: goto tr32;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st59:
	if ( ++p == pe )
		goto _test_eof59;
case 59:
	switch( (*p) ) {
		case 58u: goto st124;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st60;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st60;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st60;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st60:
	if ( ++p == pe )
		goto _test_eof60;
case 60:
	switch( (*p) ) {
		case 58u: goto st64;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st61;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st61;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st61;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st61:
	if ( ++p == pe )
		goto _test_eof61;
case 61:
	switch( (*p) ) {
		case 58u: goto st64;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st62;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st62;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st62;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st62:
	if ( ++p == pe )
		goto _test_eof62;
case 62:
	switch( (*p) ) {
		case 58u: goto st64;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st63;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st63;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st63;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st63:
	if ( ++p == pe )
		goto _test_eof63;
case 63:
	switch( (*p) ) {
		case 58u: goto st64;
		case 93u: goto tr32;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st64:
	if ( ++p == pe )
		goto _test_eof64;
case 64:
	switch( (*p) ) {
		case 58u: goto st124;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st65;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st65;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st65;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st65:
	if ( ++p == pe )
		goto _test_eof65;
case 65:
	switch( (*p) ) {
		case 58u: goto st69;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st66;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st66;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st66;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st66:
	if ( ++p == pe )
		goto _test_eof66;
case 66:
	switch( (*p) ) {
		case 58u: goto st69;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st67;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st67;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st67;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st67:
	if ( ++p == pe )
		goto _test_eof67;
case 67:
	switch( (*p) ) {
		case 58u: goto st69;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st68;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st68;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st68;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st68:
	if ( ++p == pe )
		goto _test_eof68;
case 68:
	switch( (*p) ) {
		case 58u: goto st69;
		case 93u: goto tr32;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st69:
	if ( ++p == pe )
		goto _test_eof69;
case 69:
	switch( (*p) ) {
		case 58u: goto st98;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st70;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st70;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st70;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st70:
	if ( ++p == pe )
		goto _test_eof70;
case 70:
	switch( (*p) ) {
		case 58u: goto st74;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st71;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st71;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st71;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st71:
	if ( ++p == pe )
		goto _test_eof71;
case 71:
	switch( (*p) ) {
		case 58u: goto st74;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st72;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st72;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st72;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st72:
	if ( ++p == pe )
		goto _test_eof72;
case 72:
	switch( (*p) ) {
		case 58u: goto st74;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st73;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st73;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st73;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st73:
	if ( ++p == pe )
		goto _test_eof73;
case 73:
	switch( (*p) ) {
		case 58u: goto st74;
		case 93u: goto tr32;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st74:
	if ( ++p == pe )
		goto _test_eof74;
case 74:
	switch( (*p) ) {
		case 58u: goto st98;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto tr85;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st123;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st123;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
tr85:
#line 13 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_start = p;
    }
  }
	goto st75;
st75:
	if ( ++p == pe )
		goto _test_eof75;
case 75:
#line 1855 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st91;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st88;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st97;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st97;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st76:
	if ( ++p == pe )
		goto _test_eof76;
case 76:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 48u ) {
			if ( 33u <= (*p) && (*p) <= 47u )
				goto st18;
		} else if ( (*p) > 57u ) {
			if ( 58u <= (*p) && (*p) <= 90u )
				goto st18;
		} else
			goto st77;
	} else if ( (*p) > 126u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st19;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else
			goto st20;
	} else
		goto st18;
	goto st0;
st77:
	if ( ++p == pe )
		goto _test_eof77;
case 77:
	switch( (*p) ) {
		case 46u: goto st78;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 48u ) {
			if ( 33u <= (*p) && (*p) <= 47u )
				goto st18;
		} else if ( (*p) > 57u ) {
			if ( 58u <= (*p) && (*p) <= 90u )
				goto st18;
		} else
			goto st86;
	} else if ( (*p) > 126u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st19;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else
			goto st20;
	} else
		goto st18;
	goto st0;
st78:
	if ( ++p == pe )
		goto _test_eof78;
case 78:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 48u ) {
			if ( 33u <= (*p) && (*p) <= 47u )
				goto st18;
		} else if ( (*p) > 57u ) {
			if ( 58u <= (*p) && (*p) <= 90u )
				goto st18;
		} else
			goto st79;
	} else if ( (*p) > 126u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st19;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else
			goto st20;
	} else
		goto st18;
	goto st0;
st79:
	if ( ++p == pe )
		goto _test_eof79;
case 79:
	switch( (*p) ) {
		case 46u: goto st80;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 48u ) {
			if ( 33u <= (*p) && (*p) <= 47u )
				goto st18;
		} else if ( (*p) > 57u ) {
			if ( 58u <= (*p) && (*p) <= 90u )
				goto st18;
		} else
			goto st84;
	} else if ( (*p) > 126u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st19;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else
			goto st20;
	} else
		goto st18;
	goto st0;
st80:
	if ( ++p == pe )
		goto _test_eof80;
case 80:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 48u ) {
			if ( 33u <= (*p) && (*p) <= 47u )
				goto st18;
		} else if ( (*p) > 57u ) {
			if ( 58u <= (*p) && (*p) <= 90u )
				goto st18;
		} else
			goto st81;
	} else if ( (*p) > 126u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st19;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else
			goto st20;
	} else
		goto st18;
	goto st0;
st81:
	if ( ++p == pe )
		goto _test_eof81;
case 81:
	if ( (*p) == 93u )
		goto tr99;
	if ( (*p) < 94u ) {
		if ( (*p) < 48u ) {
			if ( 33u <= (*p) && (*p) <= 47u )
				goto st18;
		} else if ( (*p) > 57u ) {
			if ( 58u <= (*p) && (*p) <= 90u )
				goto st18;
		} else
			goto st82;
	} else if ( (*p) > 126u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st19;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else
			goto st20;
	} else
		goto st18;
	goto st0;
st82:
	if ( ++p == pe )
		goto _test_eof82;
case 82:
	if ( (*p) == 93u )
		goto tr99;
	if ( (*p) < 94u ) {
		if ( (*p) < 48u ) {
			if ( 33u <= (*p) && (*p) <= 47u )
				goto st18;
		} else if ( (*p) > 57u ) {
			if ( 58u <= (*p) && (*p) <= 90u )
				goto st18;
		} else
			goto st83;
	} else if ( (*p) > 126u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st19;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else
			goto st20;
	} else
		goto st18;
	goto st0;
st83:
	if ( ++p == pe )
		goto _test_eof83;
case 83:
	if ( (*p) == 93u )
		goto tr99;
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st84:
	if ( ++p == pe )
		goto _test_eof84;
case 84:
	switch( (*p) ) {
		case 46u: goto st80;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 48u ) {
			if ( 33u <= (*p) && (*p) <= 47u )
				goto st18;
		} else if ( (*p) > 57u ) {
			if ( 58u <= (*p) && (*p) <= 90u )
				goto st18;
		} else
			goto st85;
	} else if ( (*p) > 126u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st19;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else
			goto st20;
	} else
		goto st18;
	goto st0;
st85:
	if ( ++p == pe )
		goto _test_eof85;
case 85:
	switch( (*p) ) {
		case 46u: goto st80;
		case 93u: goto tr32;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st86:
	if ( ++p == pe )
		goto _test_eof86;
case 86:
	switch( (*p) ) {
		case 46u: goto st78;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 48u ) {
			if ( 33u <= (*p) && (*p) <= 47u )
				goto st18;
		} else if ( (*p) > 57u ) {
			if ( 58u <= (*p) && (*p) <= 90u )
				goto st18;
		} else
			goto st87;
	} else if ( (*p) > 126u ) {
		if ( (*p) < 224u ) {
			if ( 192u <= (*p) && (*p) <= 223u )
				goto st19;
		} else if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else
			goto st20;
	} else
		goto st18;
	goto st0;
st87:
	if ( ++p == pe )
		goto _test_eof87;
case 87:
	switch( (*p) ) {
		case 46u: goto st78;
		case 93u: goto tr32;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st88:
	if ( ++p == pe )
		goto _test_eof88;
case 88:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st91;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st89;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st96;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st96;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st89:
	if ( ++p == pe )
		goto _test_eof89;
case 89:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st91;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st90;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st90;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st90;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st90:
	if ( ++p == pe )
		goto _test_eof90;
case 90:
	switch( (*p) ) {
		case 58u: goto st91;
		case 93u: goto tr32;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st91:
	if ( ++p == pe )
		goto _test_eof91;
case 91:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st92;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st92;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st92;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st92:
	if ( ++p == pe )
		goto _test_eof92;
case 92:
	if ( (*p) == 93u )
		goto tr108;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st93;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st93;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st93;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st93:
	if ( ++p == pe )
		goto _test_eof93;
case 93:
	if ( (*p) == 93u )
		goto tr108;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st94;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st94;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st94;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st94:
	if ( ++p == pe )
		goto _test_eof94;
case 94:
	if ( (*p) == 93u )
		goto tr108;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st95;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st95;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st95;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st95:
	if ( ++p == pe )
		goto _test_eof95;
case 95:
	if ( (*p) == 93u )
		goto tr108;
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st96:
	if ( ++p == pe )
		goto _test_eof96;
case 96:
	switch( (*p) ) {
		case 58u: goto st91;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st90;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st90;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st90;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st97:
	if ( ++p == pe )
		goto _test_eof97;
case 97:
	switch( (*p) ) {
		case 58u: goto st91;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st96;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st96;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st96;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st98:
	if ( ++p == pe )
		goto _test_eof98;
case 98:
	if ( (*p) == 93u )
		goto tr108;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st99;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st99;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st99;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st99:
	if ( ++p == pe )
		goto _test_eof99;
case 99:
	switch( (*p) ) {
		case 58u: goto st103;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st100;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st100;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st100;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st100:
	if ( ++p == pe )
		goto _test_eof100;
case 100:
	switch( (*p) ) {
		case 58u: goto st103;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st101;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st101;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st101;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st101:
	if ( ++p == pe )
		goto _test_eof101;
case 101:
	switch( (*p) ) {
		case 58u: goto st103;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st102;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st102;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st102;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st102:
	if ( ++p == pe )
		goto _test_eof102;
case 102:
	switch( (*p) ) {
		case 58u: goto st103;
		case 93u: goto tr108;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st103:
	if ( ++p == pe )
		goto _test_eof103;
case 103:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st104;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st104;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st104;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st104:
	if ( ++p == pe )
		goto _test_eof104;
case 104:
	switch( (*p) ) {
		case 58u: goto st108;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st105;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st105;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st105;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st105:
	if ( ++p == pe )
		goto _test_eof105;
case 105:
	switch( (*p) ) {
		case 58u: goto st108;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st106;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st106;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st106;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st106:
	if ( ++p == pe )
		goto _test_eof106;
case 106:
	switch( (*p) ) {
		case 58u: goto st108;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st107;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st107;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st107;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st107:
	if ( ++p == pe )
		goto _test_eof107;
case 107:
	switch( (*p) ) {
		case 58u: goto st108;
		case 93u: goto tr108;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st108:
	if ( ++p == pe )
		goto _test_eof108;
case 108:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st109;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st109;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st109;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st109:
	if ( ++p == pe )
		goto _test_eof109;
case 109:
	switch( (*p) ) {
		case 58u: goto st113;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st110;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st110;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st110;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st110:
	if ( ++p == pe )
		goto _test_eof110;
case 110:
	switch( (*p) ) {
		case 58u: goto st113;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st111;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st111;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st111;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st111:
	if ( ++p == pe )
		goto _test_eof111;
case 111:
	switch( (*p) ) {
		case 58u: goto st113;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st112;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st112;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st112;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st112:
	if ( ++p == pe )
		goto _test_eof112;
case 112:
	switch( (*p) ) {
		case 58u: goto st113;
		case 93u: goto tr108;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st113:
	if ( ++p == pe )
		goto _test_eof113;
case 113:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st114;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st114;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st114;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st114:
	if ( ++p == pe )
		goto _test_eof114;
case 114:
	switch( (*p) ) {
		case 58u: goto st118;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st115;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st115;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st115;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st115:
	if ( ++p == pe )
		goto _test_eof115;
case 115:
	switch( (*p) ) {
		case 58u: goto st118;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st116;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st116;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st116;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st116:
	if ( ++p == pe )
		goto _test_eof116;
case 116:
	switch( (*p) ) {
		case 58u: goto st118;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st117;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st117;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st117;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st117:
	if ( ++p == pe )
		goto _test_eof117;
case 117:
	switch( (*p) ) {
		case 58u: goto st118;
		case 93u: goto tr108;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st118:
	if ( ++p == pe )
		goto _test_eof118;
case 118:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st119;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st119;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st119;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st119:
	if ( ++p == pe )
		goto _test_eof119;
case 119:
	switch( (*p) ) {
		case 58u: goto st91;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st120;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st120;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st120;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st120:
	if ( ++p == pe )
		goto _test_eof120;
case 120:
	switch( (*p) ) {
		case 58u: goto st91;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st121;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st121;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st121;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st121:
	if ( ++p == pe )
		goto _test_eof121;
case 121:
	switch( (*p) ) {
		case 58u: goto st91;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st122;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st122;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st122;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st122:
	if ( ++p == pe )
		goto _test_eof122;
case 122:
	switch( (*p) ) {
		case 58u: goto st91;
		case 93u: goto tr108;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st123:
	if ( ++p == pe )
		goto _test_eof123;
case 123:
	switch( (*p) ) {
		case 58u: goto st91;
		case 93u: goto tr32;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st97;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st97;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st97;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st124:
	if ( ++p == pe )
		goto _test_eof124;
case 124:
	if ( (*p) == 93u )
		goto tr108;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto tr135;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st159;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st159;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
tr135:
#line 13 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_start = p;
    }
  }
	goto st125;
st125:
	if ( ++p == pe )
		goto _test_eof125;
case 125:
#line 3593 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st129;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st126;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st158;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st158;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st126:
	if ( ++p == pe )
		goto _test_eof126;
case 126:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st129;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st127;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st157;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st157;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st127:
	if ( ++p == pe )
		goto _test_eof127;
case 127:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st129;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st128;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st128;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st128;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st128:
	if ( ++p == pe )
		goto _test_eof128;
case 128:
	switch( (*p) ) {
		case 58u: goto st129;
		case 93u: goto tr108;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st129:
	if ( ++p == pe )
		goto _test_eof129;
case 129:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto tr143;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st156;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st156;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
tr143:
#line 13 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_start = p;
    }
  }
	goto st130;
st130:
	if ( ++p == pe )
		goto _test_eof130;
case 130:
#line 3788 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st134;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st131;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st155;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st155;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st131:
	if ( ++p == pe )
		goto _test_eof131;
case 131:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st134;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st132;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st154;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st154;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st132:
	if ( ++p == pe )
		goto _test_eof132;
case 132:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st134;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st133;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st133;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st133;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st133:
	if ( ++p == pe )
		goto _test_eof133;
case 133:
	switch( (*p) ) {
		case 58u: goto st134;
		case 93u: goto tr108;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st134:
	if ( ++p == pe )
		goto _test_eof134;
case 134:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto tr151;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st153;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st153;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
tr151:
#line 13 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_start = p;
    }
  }
	goto st135;
st135:
	if ( ++p == pe )
		goto _test_eof135;
case 135:
#line 3983 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st139;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st136;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st152;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st152;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st136:
	if ( ++p == pe )
		goto _test_eof136;
case 136:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st139;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st137;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st151;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st151;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st137:
	if ( ++p == pe )
		goto _test_eof137;
case 137:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st139;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st138;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st138;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st138;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st138:
	if ( ++p == pe )
		goto _test_eof138;
case 138:
	switch( (*p) ) {
		case 58u: goto st139;
		case 93u: goto tr108;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st139:
	if ( ++p == pe )
		goto _test_eof139;
case 139:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto tr159;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st150;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st150;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
tr159:
#line 13 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_start = p;
    }
  }
	goto st140;
st140:
	if ( ++p == pe )
		goto _test_eof140;
case 140:
#line 4178 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st144;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st141;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st149;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st149;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st141:
	if ( ++p == pe )
		goto _test_eof141;
case 141:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st144;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st142;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st148;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st148;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st142:
	if ( ++p == pe )
		goto _test_eof142;
case 142:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st144;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st143;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st143;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st143;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st143:
	if ( ++p == pe )
		goto _test_eof143;
case 143:
	switch( (*p) ) {
		case 58u: goto st144;
		case 93u: goto tr108;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
st144:
	if ( ++p == pe )
		goto _test_eof144;
case 144:
	if ( (*p) == 93u )
		goto tr32;
	if ( (*p) < 94u ) {
		if ( (*p) < 58u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto tr167;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st119;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st119;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
tr167:
#line 13 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_start = p;
    }
  }
	goto st145;
st145:
	if ( ++p == pe )
		goto _test_eof145;
case 145:
#line 4373 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st91;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st146;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st120;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st120;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st146:
	if ( ++p == pe )
		goto _test_eof146;
case 146:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st91;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st147;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st121;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st121;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st147:
	if ( ++p == pe )
		goto _test_eof147;
case 147:
	switch( (*p) ) {
		case 46u: goto st76;
		case 58u: goto st91;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st122;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st122;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st122;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st148:
	if ( ++p == pe )
		goto _test_eof148;
case 148:
	switch( (*p) ) {
		case 58u: goto st144;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st143;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st143;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st143;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st149:
	if ( ++p == pe )
		goto _test_eof149;
case 149:
	switch( (*p) ) {
		case 58u: goto st144;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st148;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st148;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st148;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st150:
	if ( ++p == pe )
		goto _test_eof150;
case 150:
	switch( (*p) ) {
		case 58u: goto st144;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st149;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st149;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st149;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st151:
	if ( ++p == pe )
		goto _test_eof151;
case 151:
	switch( (*p) ) {
		case 58u: goto st139;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st138;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st138;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st138;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st152:
	if ( ++p == pe )
		goto _test_eof152;
case 152:
	switch( (*p) ) {
		case 58u: goto st139;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st151;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st151;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st151;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st153:
	if ( ++p == pe )
		goto _test_eof153;
case 153:
	switch( (*p) ) {
		case 58u: goto st139;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st152;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st152;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st152;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st154:
	if ( ++p == pe )
		goto _test_eof154;
case 154:
	switch( (*p) ) {
		case 58u: goto st134;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st133;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st133;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st133;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st155:
	if ( ++p == pe )
		goto _test_eof155;
case 155:
	switch( (*p) ) {
		case 58u: goto st134;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st154;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st154;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st154;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st156:
	if ( ++p == pe )
		goto _test_eof156;
case 156:
	switch( (*p) ) {
		case 58u: goto st134;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st155;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st155;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st155;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st157:
	if ( ++p == pe )
		goto _test_eof157;
case 157:
	switch( (*p) ) {
		case 58u: goto st129;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st128;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st128;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st128;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st158:
	if ( ++p == pe )
		goto _test_eof158;
case 158:
	switch( (*p) ) {
		case 58u: goto st129;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st157;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st157;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st157;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
st159:
	if ( ++p == pe )
		goto _test_eof159;
case 159:
	switch( (*p) ) {
		case 58u: goto st129;
		case 93u: goto tr108;
	}
	if ( (*p) < 94u ) {
		if ( (*p) < 59u ) {
			if ( (*p) > 47u ) {
				if ( 48u <= (*p) && (*p) <= 57u )
					goto st158;
			} else if ( (*p) >= 33u )
				goto st18;
		} else if ( (*p) > 64u ) {
			if ( (*p) > 70u ) {
				if ( 71u <= (*p) && (*p) <= 90u )
					goto st18;
			} else if ( (*p) >= 65u )
				goto st158;
		} else
			goto st18;
	} else if ( (*p) > 96u ) {
		if ( (*p) < 192u ) {
			if ( (*p) > 102u ) {
				if ( 103u <= (*p) && (*p) <= 126u )
					goto st18;
			} else if ( (*p) >= 97u )
				goto st158;
		} else if ( (*p) > 223u ) {
			if ( (*p) > 239u ) {
				if ( 240u <= (*p) && (*p) <= 247u )
					goto st21;
			} else if ( (*p) >= 224u )
				goto st20;
		} else
			goto st19;
	} else
		goto st18;
	goto st0;
tr53:
#line 5 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    in_v6 = 1;
    ip_start = p;
  }
	goto st160;
st160:
	if ( ++p == pe )
		goto _test_eof160;
case 160:
#line 4997 "/startdir/src/build/src/ip_parser.rl.c"
	switch( (*p) ) {
		case 58u: goto st124;
		case 93u: goto tr32;
	}
	if ( (*p) < 192u ) {
		if ( (*p) > 90u ) {
			if ( 94u <= (*p) && (*p) <= 126u )
				goto st18;
		} else if ( (*p) >= 33u )
			goto st18;
	} else if ( (*p) > 223u ) {
		if ( (*p) > 239u ) {
			if ( 240u <= (*p) && (*p) <= 247u )
				goto st21;
		} else if ( (*p) >= 224u )
			goto st20;
	} else
		goto st19;
	goto st0;
	}
	_test_eof2: cs = 2; goto _test_eof; 
	_test_eof3: cs = 3; goto _test_eof; 
	_test_eof4: cs = 4; goto _test_eof; 
	_test_eof5: cs = 5; goto _test_eof; 
	_test_eof6: cs = 6; goto _test_eof; 
	_test_eof7: cs = 7; goto _test_eof; 
	_test_eof161: cs = 161; goto _test_eof; 
	_test_eof162: cs = 162; goto _test_eof; 
	_test_eof163: cs = 163; goto _test_eof; 
	_test_eof8: cs = 8; goto _test_eof; 
	_test_eof9: cs = 9; goto _test_eof; 
	_test_eof10: cs = 10; goto _test_eof; 
	_test_eof11: cs = 11; goto _test_eof; 
	_test_eof12: cs = 12; goto _test_eof; 
	_test_eof13: cs = 13; goto _test_eof; 
	_test_eof14: cs = 14; goto _test_eof; 
	_test_eof15: cs = 15; goto _test_eof; 
	_test_eof16: cs = 16; goto _test_eof; 
	_test_eof17: cs = 17; goto _test_eof; 
	_test_eof18: cs = 18; goto _test_eof; 
	_test_eof164: cs = 164; goto _test_eof; 
	_test_eof19: cs = 19; goto _test_eof; 
	_test_eof20: cs = 20; goto _test_eof; 
	_test_eof21: cs = 21; goto _test_eof; 
	_test_eof22: cs = 22; goto _test_eof; 
	_test_eof23: cs = 23; goto _test_eof; 
	_test_eof24: cs = 24; goto _test_eof; 
	_test_eof25: cs = 25; goto _test_eof; 
	_test_eof26: cs = 26; goto _test_eof; 
	_test_eof27: cs = 27; goto _test_eof; 
	_test_eof28: cs = 28; goto _test_eof; 
	_test_eof29: cs = 29; goto _test_eof; 
	_test_eof30: cs = 30; goto _test_eof; 
	_test_eof31: cs = 31; goto _test_eof; 
	_test_eof32: cs = 32; goto _test_eof; 
	_test_eof33: cs = 33; goto _test_eof; 
	_test_eof34: cs = 34; goto _test_eof; 
	_test_eof35: cs = 35; goto _test_eof; 
	_test_eof36: cs = 36; goto _test_eof; 
	_test_eof37: cs = 37; goto _test_eof; 
	_test_eof38: cs = 38; goto _test_eof; 
	_test_eof39: cs = 39; goto _test_eof; 
	_test_eof40: cs = 40; goto _test_eof; 
	_test_eof41: cs = 41; goto _test_eof; 
	_test_eof42: cs = 42; goto _test_eof; 
	_test_eof43: cs = 43; goto _test_eof; 
	_test_eof44: cs = 44; goto _test_eof; 
	_test_eof45: cs = 45; goto _test_eof; 
	_test_eof46: cs = 46; goto _test_eof; 
	_test_eof47: cs = 47; goto _test_eof; 
	_test_eof48: cs = 48; goto _test_eof; 
	_test_eof49: cs = 49; goto _test_eof; 
	_test_eof50: cs = 50; goto _test_eof; 
	_test_eof51: cs = 51; goto _test_eof; 
	_test_eof52: cs = 52; goto _test_eof; 
	_test_eof53: cs = 53; goto _test_eof; 
	_test_eof54: cs = 54; goto _test_eof; 
	_test_eof55: cs = 55; goto _test_eof; 
	_test_eof56: cs = 56; goto _test_eof; 
	_test_eof57: cs = 57; goto _test_eof; 
	_test_eof58: cs = 58; goto _test_eof; 
	_test_eof59: cs = 59; goto _test_eof; 
	_test_eof60: cs = 60; goto _test_eof; 
	_test_eof61: cs = 61; goto _test_eof; 
	_test_eof62: cs = 62; goto _test_eof; 
	_test_eof63: cs = 63; goto _test_eof; 
	_test_eof64: cs = 64; goto _test_eof; 
	_test_eof65: cs = 65; goto _test_eof; 
	_test_eof66: cs = 66; goto _test_eof; 
	_test_eof67: cs = 67; goto _test_eof; 
	_test_eof68: cs = 68; goto _test_eof; 
	_test_eof69: cs = 69; goto _test_eof; 
	_test_eof70: cs = 70; goto _test_eof; 
	_test_eof71: cs = 71; goto _test_eof; 
	_test_eof72: cs = 72; goto _test_eof; 
	_test_eof73: cs = 73; goto _test_eof; 
	_test_eof74: cs = 74; goto _test_eof; 
	_test_eof75: cs = 75; goto _test_eof; 
	_test_eof76: cs = 76; goto _test_eof; 
	_test_eof77: cs = 77; goto _test_eof; 
	_test_eof78: cs = 78; goto _test_eof; 
	_test_eof79: cs = 79; goto _test_eof; 
	_test_eof80: cs = 80; goto _test_eof; 
	_test_eof81: cs = 81; goto _test_eof; 
	_test_eof82: cs = 82; goto _test_eof; 
	_test_eof83: cs = 83; goto _test_eof; 
	_test_eof84: cs = 84; goto _test_eof; 
	_test_eof85: cs = 85; goto _test_eof; 
	_test_eof86: cs = 86; goto _test_eof; 
	_test_eof87: cs = 87; goto _test_eof; 
	_test_eof88: cs = 88; goto _test_eof; 
	_test_eof89: cs = 89; goto _test_eof; 
	_test_eof90: cs = 90; goto _test_eof; 
	_test_eof91: cs = 91; goto _test_eof; 
	_test_eof92: cs = 92; goto _test_eof; 
	_test_eof93: cs = 93; goto _test_eof; 
	_test_eof94: cs = 94; goto _test_eof; 
	_test_eof95: cs = 95; goto _test_eof; 
	_test_eof96: cs = 96; goto _test_eof; 
	_test_eof97: cs = 97; goto _test_eof; 
	_test_eof98: cs = 98; goto _test_eof; 
	_test_eof99: cs = 99; goto _test_eof; 
	_test_eof100: cs = 100; goto _test_eof; 
	_test_eof101: cs = 101; goto _test_eof; 
	_test_eof102: cs = 102; goto _test_eof; 
	_test_eof103: cs = 103; goto _test_eof; 
	_test_eof104: cs = 104; goto _test_eof; 
	_test_eof105: cs = 105; goto _test_eof; 
	_test_eof106: cs = 106; goto _test_eof; 
	_test_eof107: cs = 107; goto _test_eof; 
	_test_eof108: cs = 108; goto _test_eof; 
	_test_eof109: cs = 109; goto _test_eof; 
	_test_eof110: cs = 110; goto _test_eof; 
	_test_eof111: cs = 111; goto _test_eof; 
	_test_eof112: cs = 112; goto _test_eof; 
	_test_eof113: cs = 113; goto _test_eof; 
	_test_eof114: cs = 114; goto _test_eof; 
	_test_eof115: cs = 115; goto _test_eof; 
	_test_eof116: cs = 116; goto _test_eof; 
	_test_eof117: cs = 117; goto _test_eof; 
	_test_eof118: cs = 118; goto _test_eof; 
	_test_eof119: cs = 119; goto _test_eof; 
	_test_eof120: cs = 120; goto _test_eof; 
	_test_eof121: cs = 121; goto _test_eof; 
	_test_eof122: cs = 122; goto _test_eof; 
	_test_eof123: cs = 123; goto _test_eof; 
	_test_eof124: cs = 124; goto _test_eof; 
	_test_eof125: cs = 125; goto _test_eof; 
	_test_eof126: cs = 126; goto _test_eof; 
	_test_eof127: cs = 127; goto _test_eof; 
	_test_eof128: cs = 128; goto _test_eof; 
	_test_eof129: cs = 129; goto _test_eof; 
	_test_eof130: cs = 130; goto _test_eof; 
	_test_eof131: cs = 131; goto _test_eof; 
	_test_eof132: cs = 132; goto _test_eof; 
	_test_eof133: cs = 133; goto _test_eof; 
	_test_eof134: cs = 134; goto _test_eof; 
	_test_eof135: cs = 135; goto _test_eof; 
	_test_eof136: cs = 136; goto _test_eof; 
	_test_eof137: cs = 137; goto _test_eof; 
	_test_eof138: cs = 138; goto _test_eof; 
	_test_eof139: cs = 139; goto _test_eof; 
	_test_eof140: cs = 140; goto _test_eof; 
	_test_eof141: cs = 141; goto _test_eof; 
	_test_eof142: cs = 142; goto _test_eof; 
	_test_eof143: cs = 143; goto _test_eof; 
	_test_eof144: cs = 144; goto _test_eof; 
	_test_eof145: cs = 145; goto _test_eof; 
	_test_eof146: cs = 146; goto _test_eof; 
	_test_eof147: cs = 147; goto _test_eof; 
	_test_eof148: cs = 148; goto _test_eof; 
	_test_eof149: cs = 149; goto _test_eof; 
	_test_eof150: cs = 150; goto _test_eof; 
	_test_eof151: cs = 151; goto _test_eof; 
	_test_eof152: cs = 152; goto _test_eof; 
	_test_eof153: cs = 153; goto _test_eof; 
	_test_eof154: cs = 154; goto _test_eof; 
	_test_eof155: cs = 155; goto _test_eof; 
	_test_eof156: cs = 156; goto _test_eof; 
	_test_eof157: cs = 157; goto _test_eof; 
	_test_eof158: cs = 158; goto _test_eof; 
	_test_eof159: cs = 159; goto _test_eof; 
	_test_eof160: cs = 160; goto _test_eof; 

	_test_eof: {}
	if ( p == eof )
	{
	switch ( cs ) {
	case 161: 
	case 162: 
	case 163: 
#line 18 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{
    if (!in_v6) {
      ip_end = p;
    }
  }
#line 25 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"
	{}
	break;
#line 5195 "/startdir/src/build/src/ip_parser.rl.c"
	}
	}

	_out: {}
	}

#line 49 "/startdir/src/rspamd/src/ragel/smtp_ip_parser.rl"

  if (ip_start && ip_end && ip_end > ip_start) {
    return rspamd_parse_inet_address_pool (ip_start, ip_end - ip_start, pool,
    		RSPAMD_INET_ADDRESS_PARSE_NO_UNIX|RSPAMD_INET_ADDRESS_PARSE_REMOTE);
  }

  return NULL;
}